﻿Imports TestDelaunay.Delaunay

Public Class Form1
    Private Sub PictureBox1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Right Then
            'clear the screen
            ClearPoints()
        Else
            'add a point
            'This algorithm only does 2d processing on the X/Y axis. It hates duplicate points. Be sure you remove any duplicates before processing.
            'If you have data on the Z axis too, you might want to compare the Z points of any two points with the same X and Y, favoring the higher or lower Z, depending on application.

            Dim FoundDup As Boolean = False
            For i = 0 To VertexCount
                If Vertex(i).x = e.X And Vertex(i).y = e.Y Then
                    FoundDup = True
                End If
            Next

            If Not FoundDup Then
                AddVertex(e.X, e.Y, 0)
            End If

            DrawTriangles()
        End If
    End Sub


    Private Sub DrawTriangles()
        Dim bit As Bitmap = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        Dim g As Graphics = Graphics.FromImage(bit)
        Dim myPen As Pen = New Pen(Color.Blue)
        Dim i As Integer

        CalculateTriangles()
        lblStatusBar.Text = VertexCount + 1 & " points, " & TriangleCount + 1 & " triangles"

        PictureBox1.Refresh()

        If TriangleCount > -1 Then
            'draw each triangle
            For i = 0 To TriangleCount
                g.DrawLine(myPen, CInt(Vertex(Triangle(i).vv0).x), CInt(Vertex(Triangle(i).vv0).y), CInt(Vertex(Triangle(i).vv1).x), CInt(Vertex(Triangle(i).vv1).y))
                g.DrawLine(myPen, CInt(Vertex(Triangle(i).vv1).x), CInt(Vertex(Triangle(i).vv1).y), CInt(Vertex(Triangle(i).vv2).x), CInt(Vertex(Triangle(i).vv2).y))
                g.DrawLine(myPen, CInt(Vertex(Triangle(i).vv0).x), CInt(Vertex(Triangle(i).vv0).y), CInt(Vertex(Triangle(i).vv2).x), CInt(Vertex(Triangle(i).vv2).y))
            Next
        Else
            'no triangles yet, draw points instead
            For i = 0 To VertexCount
                g.DrawEllipse(myPen, CInt(Vertex(i).x) - 2, CInt(Vertex(i).y) - 2, 4, 4)
            Next
        End If

        PictureBox1.Image = bit
    End Sub


    Private Sub ClearPoints()
        EmptyVertexList()

        Dim bit As Bitmap = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        PictureBox1.Refresh()
        PictureBox1.Image = bit

        lblStatusBar.Text = "Screen cleared"
    End Sub
End Class
